
------------------------------------------------
-- DDL Statements for table SCHED
------------------------------------------------

-- DROP INDEX SCHEDTASK_IDX1;
-- DROP INDEX SCHEDTASK_IDX2;
-- DROP TABLE SCHEDLMGR;
-- DROP TABLE SCHEDLMPR;
-- DROP TABLE SCHEDTASK;
-- DROP TABLE SCHEDTREG;
-- DROP TABLESPACE SCHED_TABLESPACE;

-- CREATE TABLESPACE SCHED_TABLESPACE MANAGED BY SYSTEM USING( 'schedtmp' );

CREATE TABLE "SCHEDTASK" ("TASKID" BIGINT NOT NULL ,
              "VERSION" VARCHAR(5) NOT NULL ,
              "ROW_VERSION" INTEGER NOT NULL ,
              "TASKTYPE" INTEGER NOT NULL ,
              "TASKSUSPENDED" SMALLINT NOT NULL ,
              "CANCELLED" SMALLINT NOT NULL ,
              "NEXTFIRETIME" BIGINT NOT NULL ,
              "STARTBYINTERVAL" VARCHAR(254) ,
              "STARTBYTIME" BIGINT ,
              "VALIDFROMTIME" BIGINT ,
              "VALIDTOTIME" BIGINT ,
              "REPEATINTERVAL" VARCHAR(254) ,
              "MAXREPEATS" INTEGER NOT NULL ,
              "REPEATSLEFT" INTEGER NOT NULL ,
              "TASKINFO" BLOB(102400) LOGGED NOT COMPACT ,
              "NAME" VARCHAR(254) NOT NULL ,
              "AUTOPURGE" INTEGER NOT NULL ,
              "FAILUREACTION" INTEGER ,
              "MAXATTEMPTS" INTEGER ,
              "QOS" INTEGER ,
              "PARTITIONID" INTEGER ,
              "OWNERTOKEN" VARCHAR(200) NOT NULL ,
              "CREATETIME" BIGINT NOT NULL )  IN SCHED_TABLESPACE;

ALTER TABLE "SCHEDTASK" ADD PRIMARY KEY ("TASKID");

CREATE INDEX "SCHEDTASK_IDX1" ON "SCHEDTASK" ("TASKID",
              "OWNERTOKEN") ;

CREATE INDEX "SCHEDTASK_IDX2" ON "SCHEDTASK" ("NEXTFIRETIME" ASC,
               "REPEATSLEFT",
               "PARTITIONID") CLUSTER;

CREATE TABLE "SCHEDTREG" ("REGKEY" VARCHAR(254) NOT NULL ,
              "REGVALUE" VARCHAR(254) ) IN SCHED_TABLESPACE;

ALTER TABLE "SCHEDTREG" ADD PRIMARY KEY ("REGKEY");

CREATE TABLE "SCHEDLMGR" (LEASENAME VARCHAR(254) NOT NULL,
               LEASEOWNER VARCHAR(254) NOT NULL,
               LEASE_EXPIRE_TIME  BIGINT,
              DISABLED VARCHAR(5))IN SCHED_TABLESPACE;

ALTER TABLE "SCHEDLMGR" ADD PRIMARY KEY ("LEASENAME");

CREATE TABLE "SCHEDLMPR" (LEASENAME VARCHAR(254) NOT NULL,
              NAME VARCHAR(254) NOT NULL,
              VALUE VARCHAR(254) NOT NULL)IN SCHED_TABLESPACE;

CREATE INDEX "SCHEDLMPR_IDX1" ON "SCHEDLMPR" (LEASENAME,
               NAME);

 
QUIT;
