
------------------------------------------------
-- DDL Statements for table SCHED
------------------------------------------------

-- DROP INDEX SCHEDTASK_IDX1;
-- DROP INDEX SCHEDTASK_IDX2;
-- DROP TABLE SCHEDLMGR;
-- DROP TABLE SCHEDLMPR;
-- DROP TABLE SCHEDTASK;
-- DROP TABLE SCHEDTREG;
-- DROP TABLESPACE SCHED_TABLESPACE INCLUDING CONTENTS;

-- CREATE TABLESPACE SCHED_TABLESPACE DATAFILE 'schedtmp.dbf' SIZE 5M AUTOEXTEND ON NEXT 1M MAXSIZE UNLIMITED;
 
CREATE TABLE "SCHEDTASK"("TASKID" NUMBER(19) NOT NULL,
               "VERSION" VARCHAR2(5) NOT NULL,
               "ROW_VERSION" NUMBER(10) NOT NULL,
               "TASKTYPE" NUMBER(10) NOT NULL,
               "TASKSUSPENDED" NUMBER(1) NOT NULL,
               "CANCELLED" NUMBER(1) NOT NULL,
               "NEXTFIRETIME" NUMBER(19) NOT NULL,
               "STARTBYINTERVAL" VARCHAR2(254),
               "STARTBYTIME" NUMBER(19),
               "VALIDFROMTIME" NUMBER(19),
               "VALIDTOTIME" NUMBER(19),
               "REPEATINTERVAL" VARCHAR2(254),
               "MAXREPEATS" NUMBER(10) NOT NULL,
               "REPEATSLEFT" NUMBER(10) NOT NULL,
               "TASKINFO" BLOB,
               "NAME" VARCHAR2(254),
               "AUTOPURGE" NUMBER(10) NOT NULL,
               "FAILUREACTION" NUMBER(10),
               "MAXATTEMPTS" NUMBER(10),
               "QOS" NUMBER(10),
               "PARTITIONID" NUMBER(10),
               "OWNERTOKEN" VARCHAR2(200) NOT NULL,
               "CREATETIME" NUMBER(19) NOT NULL,
               PRIMARY KEY ("TASKID") ) TABLESPACE "SCHED_TABLESPACE";

CREATE INDEX "SCHEDTASK_IDX1" ON "SCHEDTASK" ("TASKID",
              "OWNERTOKEN") ;

CREATE INDEX "SCHEDTASK_IDX2" ON "SCHEDTASK" ("NEXTFIRETIME" ASC,
               "REPEATSLEFT",
               "PARTITIONID") ;

CREATE TABLE "SCHEDTREG" ("REGKEY" VARCHAR2(254) NOT NULL ,
               "REGVALUE" VARCHAR2(254) ,
               PRIMARY KEY ( "REGKEY" )) TABLESPACE "SCHED_TABLESPACE";

CREATE TABLE "SCHEDLMGR" ("LEASENAME" VARCHAR2(254) NOT NULL,
               "LEASEOWNER" VARCHAR2(254),
               "LEASE_EXPIRE_TIME" NUMBER(19),
               "DISABLED" VARCHAR2(254),
               PRIMARY KEY ( "LEASENAME" )) TABLESPACE "SCHED_TABLESPACE";

CREATE TABLE "SCHEDLMPR" ("LEASENAME" VARCHAR2(254) NOT NULL,
               "NAME" VARCHAR2(254) NOT NULL,
               "VALUE" VARCHAR2(254) NOT NULL ) TABLESPACE "SCHED_TABLESPACE";

CREATE INDEX "SCHEDLMPR_IDX1" ON "SCHEDLMPR" ("LEASENAME",
               "NAME") ;

QUIT;
