#   begin_generated_IBM_prolog
#
#   prolog.pro.samp.telcosp
#   ******************************************************************
#   IBM Sample Source Materials
#
#   Sample source materials are supplied As-Is.
#   No warranty is expressed or implied.
#
#   Product(s): 5724-O05 soa
#
#   (C)Copyright IBM Corp. 2008
#
#   The source code for this program supplied under the terms of the
#   End User License Agreement (EULA) that accompanied this product.
#   ******************************************************************
#
#   end_generated_IBM_prolog

import time, os, sys, os.path, shutil
from java.lang import System, Runtime, String, Long, Float, Integer, Exception
from java.util import Properties
from java.io import File, FileInputStream
from pytwss.utils import _, setLogFile, log, logScreen
import wsadmin_utils_cfg_app

COMPONENT_NAME = "spm_console"

#
# Perform the configuration process.
# param: java.util.Properties response_properties object with the defined properties
# param: deploy_info object used to query the server or cluster members.
# return: the result "SUCCESS" "FAILURE"
#
def configure(response_properties, deploy_info, selectedFeatures_properties):
    
    # Initialize variables
    component_marker_path = response_properties.getProperty("COMPONENT_MARKER_PATH")
    ddl_path = response_properties.getProperty("DDL_PATH")
    base_path = response_properties.get("TWSS_BASE_PATH")
    #marker_path = component_marker_path + os.sep + COMPONENT_NAME + ".properties"    
    marker_path = selectedFeatures_properties.getProperty("SPM_Console")
    
    # Check Marker
    #if os.path.exists(marker_path) != 1:
    if marker_path == 'false':
       log("Skip Configuring: " + COMPONENT_NAME)
       return "SUCCESS"
           	
    log("Configuring: " + COMPONENT_NAME)
    logScreen(_("SOAC7533I") %{ '1' : COMPONENT_NAME })

    # Get the Cluster or Server Id.
    dest_scope = deploy_info.getClusterId()
    if dest_scope == None or dest_scope == "":
       dest_scope = deploy_info.getServerIds()[0]
    log("Destination scope: " + dest_scope)

    # Get the app name and path.
    ear_path = base_path + os.sep + "SPM_Console.ear"
    app_name = wsadmin_utils_cfg_app.getAppName(ear_path)
    
    # Deploy the Flow EAR.
    wsadmin_utils_cfg_app.installApp (app_name, ear_path, dest_scope)
    
    # Map roles to users and groups.
    pol_adm_grp = response_properties.get('PolicyAdminGroupName')
    wsadmin_utils_cfg_app.mapRole(app_name, 'PolicyAdministrator', groups=[pol_adm_grp])
    
    return "SUCCESS"

#
# Perform the syncServers process
# param: java.util.Properties response_properties object with the defined properties 
# return: the result "SUCCESS" "FAILURE"
#
def syncServers(response_properties, deploy_info, selectedFeatures_properties):
	
    # check component marker
    component_marker_path = response_properties.getProperty("COMPONENT_MARKER_PATH")
        
    #marker_path = component_marker_path + os.sep + COMPONENT_NAME + ".properties"    
    marker_path = selectedFeatures_properties.getProperty("SPM_Console")
    #if os.path.exists(marker_path) != 1:
    if marker_path == 'false':
       log("Skip SyncServers: " + COMPONENT_NAME)
       return "SUCCESS"
           	
    log("SyncServers: " + COMPONENT_NAME)

    # do initialization
    logScreen(_("SOAC7533I") %{ '1' : COMPONENT_NAME })
    # more later
    
    return "SUCCESS"   