import wsadmin_utils
import wsadmin_utils_cfg
from pytwss.mbean.nodeagent_mbean import restartNodeAgent
from pytwss.utils import log

import com.ibm.ws.scripting.AdminConfigClient
AdminConfig = com.ibm.ws.scripting.AdminConfigClient.getInstance()

#
# Enables File Transfer capability on node agents.
# After enablement, each node agent must be restarted and has 120 seconds
# to restart before failure.  If the property is already present,
# the node agent will not be restarted.
#
# param: nodes A list of node names in which to enable file transfer.
def enableFileTransfer(nodes):
    for node in nodes:
       if wsadmin_utils.hasNodeAgent(node) == "true":
          agent = wsadmin_utils.getServerId(node, 'nodeagent')
          propid = wsadmin_utils_cfg.getJvmProperty("com.ibm.websphere.management.filetransfer.downloadPathsNotRestricted", "true", agent)
          if propid:
          	   log("File Transfer is already initialized on node (%s)." % node)
          else:
              propid = wsadmin_utils_cfg.createJvmProperty("com.ibm.websphere.management.filetransfer.downloadPathsNotRestricted", "true", agent)
              AdminConfig.save()
              restartNodeAgent(node)
       
                
#
# Disables File Transfer capability on node agents.
# After disenablement, each node agent must be restarted and has 120 seconds
# to restart before failure.
#
# param: nodes A list of node names in which to enable file transfer.
def disableFileTransfer(nodes):
    for node in nodes:
       if wsadmin_utils.hasNodeAgent(node) == "true":
          agent = wsadmin_utils.findServerId(node, 'nodeagent')
          propid = wsadmin_utils_cfg.getJvmProperty("com.ibm.websphere.management.filetransfer.downloadPathsNotRestricted", "true", agent)
          if propid:
             AdminConfig.remove(propid)
             AdminConfig.save()
          restartNodeAgent(node)
