#   begin_generated_IBM_prolog
#
#   prolog.pro.samp.telcosp
#   ******************************************************************
#   IBM Sample Source Materials
#
#   Sample source materials are supplied As-Is.
#   No warranty is expressed or implied.
#
#   Product(s): 5724-O05 soa
#
#   (C)Copyright IBM Corp. 2006, 2008
#
#   The source code for this program supplied under the terms of the
#   End User License Agreement (EULA) that accompanied this product.
#   ******************************************************************
#
#   end_generated_IBM_prolog

import sys.argv
import getopt
from com.ibm.twss.spm.admin.common import ScopedPolicy
from com.ibm.twss.spm.admin.common import PolicyValue
from java.util import Properties

from pytwss.mbean import spm_init, mbean_utils
from pytwss.utils import _, log

CN_SERVICE = 'http://www.csapi.org/wsdl/parlayx/call_notification/v2_2/interface'
CNI_SERVICE = 'http://www.csapi.org/wsdl/parlayx/call_notification/notification_manager/v2_3/interface'
CD_SERVICE = 'http://www.csapi.org/wsdl/parlayx/call_direction/v2_2/interface'
CDI_SERVICE = 'http://www.csapi.org/wsdl/parlayx/call_direction/notification_manager/v2_3/interface'
SVC_GROUP = 'Call Notification'
SERVICE_IMPL = 'PX21_CN_IMS'
CN_IMPL = 'PX21_CN_IMS_CN'
CNI_IMPL = 'PX21_CN_IMS_CNI'
CD_IMPL = 'PX21_CN_IMS_CD'
CDI_IMPL = 'PX21_CN_IMS_CDI'

def configurePolicies(response_properties, deploy_info):
	req_scope = 'ALL'
	svc_scope = SVC_GROUP
	op_scope = 'ALL'

	log(_("SOAC7520I") %{ '1' : SERVICE_IMPL })

	svc_admin = spm_init.ServiceAdministration()
	policy_admin = spm_init.PolicyAdministration()

	spm_init.registerServiceImplementation(
		svc_admin, CN_SERVICE, CN_IMPL, 1,
		'Parlay X 2.1 Call Notification IMS Service')
	spm_init.registerServiceImplementation(
		svc_admin, CNI_SERVICE, CNI_IMPL, 1,
		'Parlay X 2.1 Call Notification Notification IMS Service')
	spm_init.registerServiceImplementation(
		svc_admin, CD_SERVICE, CD_IMPL, 1,
		'Parlay X 2.1 Call Direction IMS Service')
	spm_init.registerServiceImplementation(
		svc_admin, CDI_SERVICE, CDI_IMPL, 1,
		'Parlay X 2.1 Call Direction Notification IMS Service')

        sp_root_url = response_properties.get("ServicePlatformRootURL")

	policies = [
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=CN_IMPL,
		#	operation=op_scope,
		#	name='service.Endpoint',
		#	value=PolicyValue(
		#		value=sp_root_url + "/TWSS/ParlayX21/CallNotification/IMS/services/CallNotification",
		#		type='String'
		#	),
		#),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=CNI_IMPL,
			operation=op_scope,
			name='service.Endpoint',
			value=PolicyValue(
				value=sp_root_url + "/TWSS/ParlayX21/CallNotification/IMS/services/CallNotificationManager",
				type='String'
			),
		),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=CD_IMPL,
		#	operation=op_scope,
		#	name='service.Endpoint',
		#	value=PolicyValue(
		#		value=sp_root_url + "/TWSS/ParlayX21/CallNotification/IMS/services/CallDirection",
		#		type='String'
		#	),
		#),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=CDI_IMPL,
		#	operation=op_scope,
		#	name='service.Endpoint',
		#	value=PolicyValue(
		#		value=sp_root_url + "/TWSS/ParlayX21/CallNotification/IMS/services/CallDirectionManager",
		#		type='String'
		#	),
		#),
	]
	spm_init.createPolicies(policy_admin, policies)
	log(_("SOAC7521I") %{ '1' : SERVICE_IMPL })
        
        return "SUCCESS"

if __name__ == 'main':
   if len(sys.argv) > 0:
      sp_path = sys.argv[0]
   else:
      sp_path = "http://localhost:9080/"
   p = Properties()
   p.put("ServicePlatformRootURL", sp_path)
   configurePolicies(p, None)
