#   begin_generated_IBM_prolog
#
#   prolog.pro.samp.telcosp
#   ******************************************************************
#   IBM Sample Source Materials
#
#   Sample source materials are supplied As-Is.
#   No warranty is expressed or implied.
#
#   Product(s): 5724-O05 soa
#
#   (C)Copyright IBM Corp. 2006, 2008
#
#   The source code for this program supplied under the terms of the
#   End User License Agreement (EULA) that accompanied this product.
#   ******************************************************************
#
#   end_generated_IBM_prolog

import sys.argv
import getopt
from com.ibm.twss.spm.admin.common import ScopedPolicy
from com.ibm.twss.spm.admin.common import PolicyValue
from java.util import Properties

from pytwss.mbean import spm_init, mbean_utils
from pytwss.utils import _, log

TPC_SERVICE = 'http://www.csapi.org/wsdl/parlayx/third_party_call/v2_3/interface'
SVC_GROUP = 'Third Party Call'
SERVICE_IMPL = 'PX21_TPC_IMS'

def configurePolicies(response_properties, deploy_info):
	req_scope = 'ALL'
	svc_scope = SVC_GROUP
	op_scope = 'ALL'

	log(_("SOAC7520I") %{ '1' : SERVICE_IMPL })

	svc_admin = spm_init.ServiceAdministration()
	policy_admin = spm_init.PolicyAdministration()

	spm_init.registerServiceImplementation(
		svc_admin, TPC_SERVICE, SERVICE_IMPL, 1,
		'Parlay X 2.1 Third Party Call IMS Service')

        sp_root_url = response_properties.get("ServicePlatformRootURL")

	policies = [
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.ims.PHeaderEnabled',
			value=PolicyValue(
				value='true',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.sip.GeneratedTrafficEstimate',
			value=PolicyValue(
				value='50',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.StatusRetainTime',
			value=PolicyValue(
				value='2000',
				type='Numeric'
			)
		),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.sip.OutBoundProxy',
		#	value=PolicyValue(
		#		value='<somevalue>',
		#		type='String'
		#	)
		#),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.ims.InterOperatorIdentifier',
		#	value=PolicyValue(
		#		value='<somevalue>',
		#		type='String'
		#	)
		#),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.sip.MediaServerURI',
		#	value=PolicyValue(
		#		value='<somevalue>',
		#		type='String'
		#	)
		#),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.sip.OutboundProxyResourceName',
		#	value=PolicyValue(
		#		value='<somevalue>',
		#		type='String'
		#	)
		#),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=SERVICE_IMPL,
			operation=op_scope,
			name='service.Endpoint',
			value=PolicyValue(
				value=sp_root_url + "/TWSS/ParlayX21/ThirdPartyCall/IMS/services/ThirdPartyCall",
				type='String'
			),
		),
	]
	spm_init.createPolicies(policy_admin, policies)
	log(_("SOAC7521I") %{ '1' : SERVICE_IMPL })
        
        return "SUCCESS";

if __name__ == 'main':
   if len(sys.argv) > 0:
      sp_path = sys.argv[0]
   else:
      sp_path = "http://localhost:9080/"
   p = Properties()
   p.put("ServicePlatformRootURL", sp_path)
   configurePolicies(p, None)
